/*
  Copyright (c) 2004,   Beijing Senselock Data Security Centre
  All rights reserved.
  
  File£ºsample_31_hw.c
  
  Briefs£ºThis code will 
    
*/

#include <string.h>
#include "..\..\inc\hardware\ses_v3.h"
#include "..\inc\sample_31.h"
#include "md5.h"

#define _DEBUG

/* global variable defination. */
unsigned char last_ses_error = 0; /* last SES error */
IO_PACKAGE out_pkg;  /* output package */
IO_PACKAGE *output = &out_pkg; 
IO_PACKAGE *input = (IO_PACKAGE *)pbInBuff; /* input package */

DEFINE_AT(MD5_HASH_CONTEXT , md5Ctx, 0x400, RAM_EXT);

/*
	Exit upon an error.
  
	Parameters:
		errcode[in]: error code
		msg[in]: additional error message
		msglen[in]: message length
  
	Return:
		none.

	Remarks:
		none.
*/
void error_exit(unsigned char errcode, unsigned char *msg, int msglen)
{
	output->tag = errcode;
	output->len = 0;
	
	/* for debug purpose only */
#ifdef  _DEBUG
	if (msglen != 0 && msg != NULL)
	{
		memcpy(output->buff, msg, msglen);
		output->len = msglen;
	}
#endif

	_set_response(2+output->len, (unsigned char *)output);
	_exit();
}

void main()
{
	unsigned char ret = 0;
	unsigned char length = 0;
	unsigned char i = 0;

	MD5Init(&md5Ctx);
	MD5Update(&md5Ctx, input->buff, input->len);
	MD5Final(&md5Ctx, output->buff);
	length =  0x10; // md5 hash size

	ret = _rand(1, &output->buff[length]);
	if (ret != SES_SUCCESS)
	{
		error_exit(ERR_SES, &ret, 1);
	}
	for (; i < length; i++)
	{
		output->buff[i] ^= output->buff[length];
	}
	length++;	
	output->tag = ERR_SUCCESS;
	output->len = (unsigned char)length;
	_set_response(IO_PACKAGE_HEADER_SIZE+output->len, (unsigned char *)output);
	_exit();  
}
